// Copyright (c) Microsoft Corporation. 
// Licensed under the MIT license. 

#include <string>
#include <stdlib.h>
#include <filesystem>
#include <future>
#include "SimplygonLoader.h"


void RunReduction(Simplygon::ISimplygon* sg)
{
	Simplygon::spSceneImporter sgSceneImporter = sg->CreateSceneImporter();
	sgSceneImporter->SetImportFilePath( "../Assets/RiggedSimplygonMan/RiggedSimplygonMan.fbx" );
	if(!sgSceneImporter->RunImport())
		throw std::exception("Failed to load RiggedSimplygonMan/RiggedSimplygonMan.fbx.");
	Simplygon::spScene sgScene = sgSceneImporter->GetScene();

	// Create the reduction pipeline. 
	Simplygon::spReductionPipeline sgReductionPipeline = sg->CreateReductionPipeline();

	Simplygon::spReductionSettings sgReductionSettings = sgReductionPipeline->GetReductionSettings();
	Simplygon::spBoneSettings sgBoneSettings = sgReductionPipeline->GetBoneSettings();

	// Set reduction target to triangle ratio with a ratio of 50%. 
	sgReductionSettings->SetReductionTargets( Simplygon::EStopCondition::All, true, false, false, false );
	sgReductionSettings->SetReductionTargetTriangleRatio( 0.5f );

	// Enable bone reducer. 
	sgBoneSettings->SetUseBoneReducer( true );

	// Set bone reduction target to bone ratio with a ratio of 50%. 
	sgBoneSettings->SetBoneReductionTargets( Simplygon::EStopCondition::All, true, false, false, false );
	sgBoneSettings->SetBoneReductionTargetBoneRatio( 0.5f );

	// Set bones per vertex limitations. 
	sgBoneSettings->SetLimitBonesPerVertex( true );
	sgBoneSettings->SetMaxBonePerVertex( 64 );

	// Remove unused bones. 
	sgBoneSettings->SetRemoveUnusedBones( true );

	// Start the reduction pipeline. 
	sgReductionPipeline->RunScene(sgScene, Simplygon::EPipelineRunMode::RunInThisProcess);

	// Get the processed scene. 
	Simplygon::spScene sgProcessedScene = sgReductionPipeline->GetProcessedScene();

	Simplygon::spSceneExporter  sgSceneExporter = sg->CreateSceneExporter();
	sgSceneExporter->SetScene(sgProcessedScene);
	sgSceneExporter->SetExportFilePath( "ReductionOutput.fbx" );
	if(!sgSceneExporter->RunExport())
		throw std::exception("Failed to save ReductionOutput.fbx.");

}

void main()
{
	Simplygon::ISimplygon* sg = NULL;
	Simplygon::EErrorCodes initval = Simplygon::Initialize( &sg );
	if( initval != Simplygon::EErrorCodes::NoError )
	{
		return;
	}

	RunReduction(sg);

	Simplygon::Deinitialize(sg);
}

